#include "Flower.h"

using namespace std;

void constructorDestructor(){
	Plant p;					//default constr Plant
	p.setName("name1");			//setName from Plant
	char* s = p.toString() ;	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}

	Flower f;					//default constr Plant + Flower
	f.setName("name2");			//setName from Plant
	f.setNoPetals(4);			//setNoPEtals from Flower
	s = f.toString();			//Flower::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}

	Plant p2("name3");	//general constr Plant
	s = p2.toString() ;	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}

	Flower f2("name4", 5);		//general constr Plant + Flower
	s = f2.toString();			//Flower::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}
}

void assignmentsBaseDerived(){
	Plant p;					//default constr Plant
	p.setName("name1");			//setName from Plant
	Flower f;					//default constr Plant + Flower
	f.setName("name2");			//setName from Plant
	f.setNoPetals(4);			//setNoPEtals from Flower

	Plant p1 = f;	//base = derived

	//Flower f1 = p;	//error !!! derived = base
}

void references(){
	Plant p;					//default constr Plant
	p.setName("name1");			//setName from Plant
	Flower f;					//default constr Plant + Flower
	f.setName("name2");			//setName from Plant
	f.setNoPetals(4);			//setNoPEtals from Flower

	Plant &p2 = p;
	char* s = p2.toString();	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}

	Plant &p3 = f;
	s = p3.toString();	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}
}

void pointers(){
	Plant p;					//default constr Plant
	p.setName("name1");			//setName from Plant
	Flower f;					//default constr Plant + Flower
	f.setName("name2");			//setName from Plant
	f.setNoPetals(4);			//setNoPEtals from Flower

	Plant* pp = &p;
	char* s = pp->toString();	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}

	Plant* pf = &f;
	s = pf->toString();	//Plant::toString()
	cout << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}
}

int main(){
	constructorDestructor();
	assignmentsBaseDerived();
	references();
	pointers();
	return 0;
}